# synfig::Layer_Bitmap Class Reference

`#include <layer_bitmap.h>`

Inheritance diagram for synfig::Layer_Bitmap:

List of all members.

## Public Types

typedef etl::handle< Layer_Bitmap > | Handle

## Public Member Functions

| Layer_Bitmap ()
virtual bool | set_param (const String &param, ValueBase value)
virtual ValueBase | get_param (const String &param) const
| Get the value of the specified parameter.
virtual Color | get_color (Context context, const Point &pos) const
| Gets the color of the Canvas at pos.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual Rect | get_bounding_rect () const
virtual bool | accelerated_render (Context context, Surface *surface, int quality, const RendDesc &renddesc, ProgressCallback *cb) const
| Renders the Canvas to the given Surface in an accelerated manner.
virtual synfig::Layer::Handle | hit_check (synfig::Context context, const synfig::Point &point) const
| Checks to see if a part of the layer is directly under point.

## Public Attributes

Point | tl
Point | br
int | c
Surface | surface
bool | trimmed
unsigned int | width
unsigned int | height
unsigned int | top
unsigned int | left
Real | gamma_adjust

## Detailed Description

Todo:
  writeme

## Member Typedef Documentation

typedef etl::handle<Layer_Bitmap> synfig::Layer_Bitmap::Handle

Reimplemented from synfig::Layer.

## Constructor & Destructor Documentation

synfig::Layer_Bitmap::Layer_Bitmap | ( |  | ) |

## Member Function Documentation

bool synfig::Layer_Bitmap::set_param | ( | const String & | param,
|  | ValueBase | value |
| ) |  |  | `[virtual]`

References br, c, gamma_adjust, synfig::ValueBase::get(), synfig::ValueBase::get_type(), IMPORT, synfig::Layer_Composite::set_param(), tl, and synfig::ValueBase::TYPE_REAL.

ValueBase synfig::Layer_Bitmap::get_param | ( | const String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

Reimplemented in Import.

References br, c, EXPORT, gamma_adjust, synfig::Layer_Composite::get_param(), height, surface, tl, trimmed, and width.

Color synfig::Layer_Bitmap::get_color | ( | Context | context,
|  | const Point & | pos |
| ) |  |  | const`[virtual]`

Gets the color of the Canvas at pos.

Parameters:

  | context | Context iterator referring to next Layer.
  | pos | Point which indicates where the Color should come from

See also:
  Handle::get_color()

Reimplemented from synfig::Layer.

References synfig::Color::alpha(), synfig::Color::blend(), synfig::Color::BLEND_STRAIGHT, br, c, synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::Context::get_color(), height, left, surface, tl, top, trimmed, and width.

Layer::Vocab Layer_Bitmap::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

Reimplemented in Import.

References _, synfig::Layer_Composite::get_param_vocab(), and synfig::Layer::set_description().

Rect Layer_Bitmap::get_bounding_rect | ( |  | ) | const`[virtual]`

Reimplemented from synfig::Layer.

References br, and tl.

bool Layer_Bitmap::accelerated_render | ( | Context | context,
|  | Surface * | surface,
|  | int | quality,
|  | const RendDesc & | renddesc,
|  | ProgressCallback * | cb |
| ) |  |  | const`[virtual]`

Renders the Canvas to the given Surface in an accelerated manner.

Parameters:

  | context | Context iterator referring to next Layer.
  | surface | Pointer to Surface to render to.
  | quality | The requested quality-level to render at.
  | renddesc | The associated RendDesc.
  | cb | Pointer to callback object. May be NULL if there is no callback.

Returns:
  `true` on success, `false` on failure

See also:
  Handle::accelerated_render()

Reimplemented from synfig::Layer_Composite.

References synfig::Context::accelerated_render(), synfig::ProgressCallback::amount_complete(), synfig::Color::BLEND_STRAIGHT, br, c, gamma_adjust, synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::RendDesc::get_br(), synfig::RendDesc::get_h(), synfig::RendDesc::get_tl(), synfig::RendDesc::get_w(), height, left, surface, tl, top, trimmed, and width.

synfig::Layer::Handle Layer_Bitmap::hit_check | ( | synfig::Context | context,
|  | const synfig::Point & | point |
| ) |  |  | const`[virtual]`

Checks to see if a part of the layer is directly under point.

Parameters:

  | context | Context iterator referring to next Layer.
  | point | The point to check

Returns:
  The handle of the layer under point. If there is not a layer under point, then returns an empty handle.

Reimplemented from synfig::Layer.

References br, synfig::Context::hit_check(), and tl.

## Member Data Documentation

Point synfig::Layer_Bitmap::tl

Referenced by accelerated_render(), get_bounding_rect(), get_color(), get_param(), hit_check(), and set_param().

Point synfig::Layer_Bitmap::br

Referenced by accelerated_render(), get_bounding_rect(), get_color(), get_param(), hit_check(), and set_param().

int synfig::Layer_Bitmap::c

Referenced by accelerated_render(), get_color(), get_param(), and set_param().

Surface synfig::Layer_Bitmap::surface `[mutable]`

Referenced by accelerated_render(), get_color(), get_param(), Import::set_param(), and Import::set_time().

bool synfig::Layer_Bitmap::trimmed `[mutable]`

Referenced by accelerated_render(), get_color(), get_param(), Import::set_param(), and Import::set_time().

unsigned int synfig::Layer_Bitmap::width `[mutable]`

Referenced by accelerated_render(), get_color(), get_param(), Import::set_param(), and Import::set_time().

unsigned int synfig::Layer_Bitmap::height `[mutable]`

Referenced by accelerated_render(), get_color(), get_param(), Import::set_param(), and Import::set_time().

unsigned int synfig::Layer_Bitmap::top `[mutable]`

Referenced by accelerated_render(), get_color(), Import::set_param(), and Import::set_time().

unsigned int synfig::Layer_Bitmap::left `[mutable]`

Referenced by accelerated_render(), get_color(), Import::set_param(), and Import::set_time().

Real synfig::Layer_Bitmap::gamma_adjust

Referenced by accelerated_render(), get_param(), and set_param().

The documentation for this class was generated from the following files:

- layer_bitmap.h
- layer_bitmap.cpp